
/******************************************************************************
* MODULE     : kwd_use.cc
* DESCRIPTION: Using extern modules
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <dlfcn.h>
#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::kw_use_1 () {
  CHECK_SYNC (MMX_USE);
  if (N (car (trace)) != 2) error (car (trace), "Bad use instruction");
  list name (MMX_TRANSTYPE, car (trace) [1], VAL_STRING);
  evaluate_arg (name, KW_USE_2);
}

void
evaluator_rep::kw_use_2 () {
  CHECK_SYNC (MMX_USE);
  // Input: (use_2, module_name, cont, ...)
  string name= as_string (V (car (rem)));
  string lib = name * ".mmx.so";
  string rout= "init_" * name; // attention to mangling by C+
  char* _lib = as_charp (lib);
  char* _rout= as_charp (rout);

  void* handle= dlopen (_lib, RTLD_LAZY | RTLD_GLOBAL);
  if (handle == NULL) {
    error (car (trace), dlerror ()); 
    // cerr << "Dynamic library " << lib << " did not open\n";
    return;
  }
  else {
    void* f= dlsym (handle, _rout);
    if (f == NULL) {
      error (car (trace), "Symbol " * rout * " not defined in " * lib);
      return;
    }
    else {
      void (*init) (void)= (void (*) (void)) f;
      init ();
    }
  }
  cur= cadr (rem);
  rem= cons (VAL_NONE, cddr (rem));
  // Output: (cont, none, ...)
  trace= cdr (trace);
}

} // namespace mmx
